import{S as Wt,i as jt,s as zt,e as o,k as l,w as V,t as i,M as Bt,c as n,d as r,m as c,a as s,x as H,h as a,b as d,G as e,g as u,y as J,L as Kt,q as U,o as G,B as R,v as Qt}from"../../../chunks/vendor-hf-doc-builder.js";import{D as $e}from"../../../chunks/Docstring-hf-doc-builder.js";import{I as vt}from"../../../chunks/IconCopyLink-hf-doc-builder.js";function Xt(bt){let _,pe,v,y,Y,E,Ee,Z,Ae,fe,b,P,ee,A,Te,te,Ne,he,T,N,Oe,Ce,ue,W,Fe,me,j,Ie,ge,x,Le,O,ke,qe,_e,D,w,re,C,Ve,oe,He,ve,p,F,Je,ne,Ue,Ge,h,z,Re,We,se,je,ze,ie,Be,Ke,ae,Qe,Xe,B,Ye,Ze,K,et,tt,Q,rt,ot,nt,X,st,I,it,at,M,L,dt,de,lt,ct,S,k,pt,le,ft,ht,$,q,ut,ce,mt,be;return E=new vt({}),A=new vt({}),C=new vt({}),F=new $e({props:{name:"class diffusers.DDPMScheduler",anchor:"diffusers.DDPMScheduler",parameters:[{name:"num_train_timesteps",val:": int = 1000"},{name:"beta_start",val:": float = 0.0001"},{name:"beta_end",val:": float = 0.02"},{name:"beta_schedule",val:": str = 'linear'"},{name:"trained_betas",val:": typing.Union[numpy.ndarray, typing.List[float], NoneType] = None"},{name:"variance_type",val:": str = 'fixed_small'"},{name:"clip_sample",val:": bool = True"},{name:"prediction_type",val:": str = 'epsilon'"},{name:"thresholding",val:": bool = False"},{name:"dynamic_thresholding_ratio",val:": float = 0.995"},{name:"clip_sample_range",val:": float = 1.0"},{name:"sample_max_value",val:": float = 1.0"}],parametersDescription:[{anchor:"diffusers.DDPMScheduler.num_train_timesteps",description:"<strong>num_train_timesteps</strong> (<code>int</code>) &#x2014; number of diffusion steps used to train the model.",name:"num_train_timesteps"},{anchor:"diffusers.DDPMScheduler.beta_start",description:"<strong>beta_start</strong> (<code>float</code>) &#x2014; the starting <code>beta</code> value of inference.",name:"beta_start"},{anchor:"diffusers.DDPMScheduler.beta_end",description:"<strong>beta_end</strong> (<code>float</code>) &#x2014; the final <code>beta</code> value.",name:"beta_end"},{anchor:"diffusers.DDPMScheduler.beta_schedule",description:`<strong>beta_schedule</strong> (<code>str</code>) &#x2014;
the beta schedule, a mapping from a beta range to a sequence of betas for stepping the model. Choose from
<code>linear</code>, <code>scaled_linear</code>, or <code>squaredcos_cap_v2</code>.`,name:"beta_schedule"},{anchor:"diffusers.DDPMScheduler.trained_betas",description:`<strong>trained_betas</strong> (<code>np.ndarray</code>, optional) &#x2014;
option to pass an array of betas directly to the constructor to bypass <code>beta_start</code>, <code>beta_end</code> etc.`,name:"trained_betas"},{anchor:"diffusers.DDPMScheduler.variance_type",description:`<strong>variance_type</strong> (<code>str</code>) &#x2014;
options to clip the variance used when adding noise to the denoised sample. Choose from <code>fixed_small</code>,
<code>fixed_small_log</code>, <code>fixed_large</code>, <code>fixed_large_log</code>, <code>learned</code> or <code>learned_range</code>.`,name:"variance_type"},{anchor:"diffusers.DDPMScheduler.clip_sample",description:`<strong>clip_sample</strong> (<code>bool</code>, default <code>True</code>) &#x2014;
option to clip predicted sample for numerical stability.`,name:"clip_sample"},{anchor:"diffusers.DDPMScheduler.clip_sample_range",description:`<strong>clip_sample_range</strong> (<code>float</code>, default <code>1.0</code>) &#x2014;
the maximum magnitude for sample clipping. Valid only when <code>clip_sample=True</code>.`,name:"clip_sample_range"},{anchor:"diffusers.DDPMScheduler.prediction_type",description:`<strong>prediction_type</strong> (<code>str</code>, default <code>epsilon</code>, optional) &#x2014;
prediction type of the scheduler function, one of <code>epsilon</code> (predicting the noise of the diffusion
process), <code>sample</code> (directly predicting the noisy sample<code>) or </code>v_prediction\` (see section 2.4
<a href="https://imagen.research.google/video/paper.pdf" rel="nofollow">https://imagen.research.google/video/paper.pdf</a>)`,name:"prediction_type"},{anchor:"diffusers.DDPMScheduler.thresholding",description:`<strong>thresholding</strong> (<code>bool</code>, default <code>False</code>) &#x2014;
whether to use the &#x201C;dynamic thresholding&#x201D; method (introduced by Imagen, <a href="https://arxiv.org/abs/2205.11487" rel="nofollow">https://arxiv.org/abs/2205.11487</a>).
Note that the thresholding method is unsuitable for latent-space diffusion models (such as
stable-diffusion).`,name:"thresholding"},{anchor:"diffusers.DDPMScheduler.dynamic_thresholding_ratio",description:`<strong>dynamic_thresholding_ratio</strong> (<code>float</code>, default <code>0.995</code>) &#x2014;
the ratio for the dynamic thresholding method. Default is <code>0.995</code>, the same as Imagen
(<a href="https://arxiv.org/abs/2205.11487" rel="nofollow">https://arxiv.org/abs/2205.11487</a>). Valid only when <code>thresholding=True</code>.`,name:"dynamic_thresholding_ratio"},{anchor:"diffusers.DDPMScheduler.sample_max_value",description:`<strong>sample_max_value</strong> (<code>float</code>, default <code>1.0</code>) &#x2014;
the threshold value for dynamic thresholding. Valid only when <code>thresholding=True</code>.`,name:"sample_max_value"}],source:"https://github.com/huggingface/diffusers/blob/vr_3066/src/diffusers/schedulers/scheduling_ddpm.py#L76"}}),L=new $e({props:{name:"scale_model_input",anchor:"diffusers.DDPMScheduler.scale_model_input",parameters:[{name:"sample",val:": FloatTensor"},{name:"timestep",val:": typing.Optional[int] = None"}],parametersDescription:[{anchor:"diffusers.DDPMScheduler.scale_model_input.sample",description:"<strong>sample</strong> (<code>torch.FloatTensor</code>) &#x2014; input sample",name:"sample"},{anchor:"diffusers.DDPMScheduler.scale_model_input.timestep",description:"<strong>timestep</strong> (<code>int</code>, optional) &#x2014; current timestep",name:"timestep"}],source:"https://github.com/huggingface/diffusers/blob/vr_3066/src/diffusers/schedulers/scheduling_ddpm.py#L180",returnDescription:`
<p>scaled input sample</p>
`,returnType:`
<p><code>torch.FloatTensor</code></p>
`}}),k=new $e({props:{name:"set_timesteps",anchor:"diffusers.DDPMScheduler.set_timesteps",parameters:[{name:"num_inference_steps",val:": int"},{name:"device",val:": typing.Union[str, torch.device] = None"}],parametersDescription:[{anchor:"diffusers.DDPMScheduler.set_timesteps.num_inference_steps",description:`<strong>num_inference_steps</strong> (<code>int</code>) &#x2014;
the number of diffusion steps used when generating samples with a pre-trained model.`,name:"num_inference_steps"}],source:"https://github.com/huggingface/diffusers/blob/vr_3066/src/diffusers/schedulers/scheduling_ddpm.py#L194"}}),q=new $e({props:{name:"step",anchor:"diffusers.DDPMScheduler.step",parameters:[{name:"model_output",val:": FloatTensor"},{name:"timestep",val:": int"},{name:"sample",val:": FloatTensor"},{name:"generator",val:" = None"},{name:"return_dict",val:": bool = True"}],parametersDescription:[{anchor:"diffusers.DDPMScheduler.step.model_output",description:"<strong>model_output</strong> (<code>torch.FloatTensor</code>) &#x2014; direct output from learned diffusion model.",name:"model_output"},{anchor:"diffusers.DDPMScheduler.step.timestep",description:"<strong>timestep</strong> (<code>int</code>) &#x2014; current discrete timestep in the diffusion chain.",name:"timestep"},{anchor:"diffusers.DDPMScheduler.step.sample",description:`<strong>sample</strong> (<code>torch.FloatTensor</code>) &#x2014;
current instance of sample being created by diffusion process.
generator &#x2014; random number generator.`,name:"sample"},{anchor:"diffusers.DDPMScheduler.step.return_dict",description:"<strong>return_dict</strong> (<code>bool</code>) &#x2014; option for returning tuple rather than DDPMSchedulerOutput class",name:"return_dict"}],source:"https://github.com/huggingface/diffusers/blob/vr_3066/src/diffusers/schedulers/scheduling_ddpm.py#L290",returnDescription:`
<p><code>~schedulers.scheduling_utils.DDPMSchedulerOutput</code> if <code>return_dict</code> is True, otherwise a <code>tuple</code>. When
returning a tuple, the first element is the sample tensor.</p>
`,returnType:`
<p><code>~schedulers.scheduling_utils.DDPMSchedulerOutput</code> or <code>tuple</code></p>
`}}),{c(){_=o("meta"),pe=l(),v=o("h1"),y=o("a"),Y=o("span"),V(E.$$.fragment),Ee=l(),Z=o("span"),Ae=i("Denoising Diffusion Probabilistic Models (DDPM)"),fe=l(),b=o("h2"),P=o("a"),ee=o("span"),V(A.$$.fragment),Te=l(),te=o("span"),Ne=i("Overview"),he=l(),T=o("p"),N=o("a"),Oe=i("Denoising Diffusion Probabilistic Models"),Ce=i(`
(DDPM) by Jonathan Ho, Ajay Jain and Pieter Abbeel proposes the diffusion based model of the same name, but in the context of the \u{1F917} Diffusers library, DDPM refers to the discrete denoising scheduler from the paper as well as the pipeline.`),ue=l(),W=o("p"),Fe=i("The abstract of the paper is the following:"),me=l(),j=o("p"),Ie=i("We present high quality image synthesis results using diffusion probabilistic models, a class of latent variable models inspired by considerations from nonequilibrium thermodynamics. Our best results are obtained by training on a weighted variational bound designed according to a novel connection between diffusion probabilistic models and denoising score matching with Langevin dynamics, and our models naturally admit a progressive lossy decompression scheme that can be interpreted as a generalization of autoregressive decoding. On the unconditional CIFAR10 dataset, we obtain an Inception score of 9.46 and a state-of-the-art FID score of 3.17. On 256x256 LSUN, we obtain sample quality similar to ProgressiveGAN."),ge=l(),x=o("p"),Le=i("The original paper can be found "),O=o("a"),ke=i("here"),qe=i("."),_e=l(),D=o("h2"),w=o("a"),re=o("span"),V(C.$$.fragment),Ve=l(),oe=o("span"),He=i("DDPMScheduler"),ve=l(),p=o("div"),V(F.$$.fragment),Je=l(),ne=o("p"),Ue=i(`Denoising diffusion probabilistic models (DDPMs) explores the connections between denoising score matching and
Langevin dynamics sampling.`),Ge=l(),h=o("p"),z=o("a"),Re=i("~ConfigMixin"),We=i(" takes care of storing all config attributes that are passed in the scheduler\u2019s "),se=o("code"),je=i("__init__"),ze=i(`
function, such as `),ie=o("code"),Be=i("num_train_timesteps"),Ke=i(". They can be accessed via "),ae=o("code"),Qe=i("scheduler.config.num_train_timesteps"),Xe=i(`.
`),B=o("a"),Ye=i("SchedulerMixin"),Ze=i(" provides general loading and saving functionality via the "),K=o("a"),et=i("SchedulerMixin.save_pretrained()"),tt=i(` and
`),Q=o("a"),rt=i("from_pretrained()"),ot=i(" functions."),nt=l(),X=o("p"),st=i("For more details, see the original paper: "),I=o("a"),it=i("https://arxiv.org/abs/2006.11239"),at=l(),M=o("div"),V(L.$$.fragment),dt=l(),de=o("p"),lt=i(`Ensures interchangeability with schedulers that need to scale the denoising model input depending on the
current timestep.`),ct=l(),S=o("div"),V(k.$$.fragment),pt=l(),le=o("p"),ft=i("Sets the discrete timesteps used for the diffusion chain. Supporting function to be run before inference."),ht=l(),$=o("div"),V(q.$$.fragment),ut=l(),ce=o("p"),mt=i(`Predict the sample at the previous timestep by reversing the SDE. Core function to propagate the diffusion
process from the learned model outputs (most often the predicted noise).`),this.h()},l(t){const f=Bt('[data-svelte="svelte-1phssyn"]',document.head);_=n(f,"META",{name:!0,content:!0}),f.forEach(r),pe=c(t),v=n(t,"H1",{class:!0});var De=s(v);y=n(De,"A",{id:!0,class:!0,href:!0});var Dt=s(y);Y=n(Dt,"SPAN",{});var yt=s(Y);H(E.$$.fragment,yt),yt.forEach(r),Dt.forEach(r),Ee=c(De),Z=n(De,"SPAN",{});var Pt=s(Z);Ae=a(Pt,"Denoising Diffusion Probabilistic Models (DDPM)"),Pt.forEach(r),De.forEach(r),fe=c(t),b=n(t,"H2",{class:!0});var ye=s(b);P=n(ye,"A",{id:!0,class:!0,href:!0});var xt=s(P);ee=n(xt,"SPAN",{});var wt=s(ee);H(A.$$.fragment,wt),wt.forEach(r),xt.forEach(r),Te=c(ye),te=n(ye,"SPAN",{});var Mt=s(te);Ne=a(Mt,"Overview"),Mt.forEach(r),ye.forEach(r),he=c(t),T=n(t,"P",{});var gt=s(T);N=n(gt,"A",{href:!0,rel:!0});var St=s(N);Oe=a(St,"Denoising Diffusion Probabilistic Models"),St.forEach(r),Ce=a(gt,`
(DDPM) by Jonathan Ho, Ajay Jain and Pieter Abbeel proposes the diffusion based model of the same name, but in the context of the \u{1F917} Diffusers library, DDPM refers to the discrete denoising scheduler from the paper as well as the pipeline.`),gt.forEach(r),ue=c(t),W=n(t,"P",{});var $t=s(W);Fe=a($t,"The abstract of the paper is the following:"),$t.forEach(r),me=c(t),j=n(t,"P",{});var Et=s(j);Ie=a(Et,"We present high quality image synthesis results using diffusion probabilistic models, a class of latent variable models inspired by considerations from nonequilibrium thermodynamics. Our best results are obtained by training on a weighted variational bound designed according to a novel connection between diffusion probabilistic models and denoising score matching with Langevin dynamics, and our models naturally admit a progressive lossy decompression scheme that can be interpreted as a generalization of autoregressive decoding. On the unconditional CIFAR10 dataset, we obtain an Inception score of 9.46 and a state-of-the-art FID score of 3.17. On 256x256 LSUN, we obtain sample quality similar to ProgressiveGAN."),Et.forEach(r),ge=c(t),x=n(t,"P",{});var Pe=s(x);Le=a(Pe,"The original paper can be found "),O=n(Pe,"A",{href:!0,rel:!0});var At=s(O);ke=a(At,"here"),At.forEach(r),qe=a(Pe,"."),Pe.forEach(r),_e=c(t),D=n(t,"H2",{class:!0});var xe=s(D);w=n(xe,"A",{id:!0,class:!0,href:!0});var Tt=s(w);re=n(Tt,"SPAN",{});var Nt=s(re);H(C.$$.fragment,Nt),Nt.forEach(r),Tt.forEach(r),Ve=c(xe),oe=n(xe,"SPAN",{});var Ot=s(oe);He=a(Ot,"DDPMScheduler"),Ot.forEach(r),xe.forEach(r),ve=c(t),p=n(t,"DIV",{class:!0});var g=s(p);H(F.$$.fragment,g),Je=c(g),ne=n(g,"P",{});var Ct=s(ne);Ue=a(Ct,`Denoising diffusion probabilistic models (DDPMs) explores the connections between denoising score matching and
Langevin dynamics sampling.`),Ct.forEach(r),Ge=c(g),h=n(g,"P",{});var m=s(h);z=n(m,"A",{href:!0});var Ft=s(z);Re=a(Ft,"~ConfigMixin"),Ft.forEach(r),We=a(m," takes care of storing all config attributes that are passed in the scheduler\u2019s "),se=n(m,"CODE",{});var It=s(se);je=a(It,"__init__"),It.forEach(r),ze=a(m,`
function, such as `),ie=n(m,"CODE",{});var Lt=s(ie);Be=a(Lt,"num_train_timesteps"),Lt.forEach(r),Ke=a(m,". They can be accessed via "),ae=n(m,"CODE",{});var kt=s(ae);Qe=a(kt,"scheduler.config.num_train_timesteps"),kt.forEach(r),Xe=a(m,`.
`),B=n(m,"A",{href:!0});var qt=s(B);Ye=a(qt,"SchedulerMixin"),qt.forEach(r),Ze=a(m," provides general loading and saving functionality via the "),K=n(m,"A",{href:!0});var Vt=s(K);et=a(Vt,"SchedulerMixin.save_pretrained()"),Vt.forEach(r),tt=a(m,` and
`),Q=n(m,"A",{href:!0});var Ht=s(Q);rt=a(Ht,"from_pretrained()"),Ht.forEach(r),ot=a(m," functions."),m.forEach(r),nt=c(g),X=n(g,"P",{});var _t=s(X);st=a(_t,"For more details, see the original paper: "),I=n(_t,"A",{href:!0,rel:!0});var Jt=s(I);it=a(Jt,"https://arxiv.org/abs/2006.11239"),Jt.forEach(r),_t.forEach(r),at=c(g),M=n(g,"DIV",{class:!0});var we=s(M);H(L.$$.fragment,we),dt=c(we),de=n(we,"P",{});var Ut=s(de);lt=a(Ut,`Ensures interchangeability with schedulers that need to scale the denoising model input depending on the
current timestep.`),Ut.forEach(r),we.forEach(r),ct=c(g),S=n(g,"DIV",{class:!0});var Me=s(S);H(k.$$.fragment,Me),pt=c(Me),le=n(Me,"P",{});var Gt=s(le);ft=a(Gt,"Sets the discrete timesteps used for the diffusion chain. Supporting function to be run before inference."),Gt.forEach(r),Me.forEach(r),ht=c(g),$=n(g,"DIV",{class:!0});var Se=s($);H(q.$$.fragment,Se),ut=c(Se),ce=n(Se,"P",{});var Rt=s(ce);mt=a(Rt,`Predict the sample at the previous timestep by reversing the SDE. Core function to propagate the diffusion
process from the learned model outputs (most often the predicted noise).`),Rt.forEach(r),Se.forEach(r),g.forEach(r),this.h()},h(){d(_,"name","hf:doc:metadata"),d(_,"content",JSON.stringify(Yt)),d(y,"id","denoising-diffusion-probabilistic-models-ddpm"),d(y,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(y,"href","#denoising-diffusion-probabilistic-models-ddpm"),d(v,"class","relative group"),d(P,"id","overview"),d(P,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(P,"href","#overview"),d(b,"class","relative group"),d(N,"href","https://arxiv.org/abs/2006.11239"),d(N,"rel","nofollow"),d(O,"href","https://arxiv.org/abs/2010.02502"),d(O,"rel","nofollow"),d(w,"id","diffusers.DDPMScheduler"),d(w,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(w,"href","#diffusers.DDPMScheduler"),d(D,"class","relative group"),d(z,"href","/docs/diffusers/pr_3066/en/api/configuration#diffusers.ConfigMixin"),d(B,"href","/docs/diffusers/pr_3066/en/api/schedulers/overview#diffusers.SchedulerMixin"),d(K,"href","/docs/diffusers/pr_3066/en/api/schedulers/overview#diffusers.SchedulerMixin.save_pretrained"),d(Q,"href","/docs/diffusers/pr_3066/en/api/schedulers/overview#diffusers.SchedulerMixin.from_pretrained"),d(I,"href","https://arxiv.org/abs/2006.11239"),d(I,"rel","nofollow"),d(M,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(S,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d($,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(p,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(t,f){e(document.head,_),u(t,pe,f),u(t,v,f),e(v,y),e(y,Y),J(E,Y,null),e(v,Ee),e(v,Z),e(Z,Ae),u(t,fe,f),u(t,b,f),e(b,P),e(P,ee),J(A,ee,null),e(b,Te),e(b,te),e(te,Ne),u(t,he,f),u(t,T,f),e(T,N),e(N,Oe),e(T,Ce),u(t,ue,f),u(t,W,f),e(W,Fe),u(t,me,f),u(t,j,f),e(j,Ie),u(t,ge,f),u(t,x,f),e(x,Le),e(x,O),e(O,ke),e(x,qe),u(t,_e,f),u(t,D,f),e(D,w),e(w,re),J(C,re,null),e(D,Ve),e(D,oe),e(oe,He),u(t,ve,f),u(t,p,f),J(F,p,null),e(p,Je),e(p,ne),e(ne,Ue),e(p,Ge),e(p,h),e(h,z),e(z,Re),e(h,We),e(h,se),e(se,je),e(h,ze),e(h,ie),e(ie,Be),e(h,Ke),e(h,ae),e(ae,Qe),e(h,Xe),e(h,B),e(B,Ye),e(h,Ze),e(h,K),e(K,et),e(h,tt),e(h,Q),e(Q,rt),e(h,ot),e(p,nt),e(p,X),e(X,st),e(X,I),e(I,it),e(p,at),e(p,M),J(L,M,null),e(M,dt),e(M,de),e(de,lt),e(p,ct),e(p,S),J(k,S,null),e(S,pt),e(S,le),e(le,ft),e(p,ht),e(p,$),J(q,$,null),e($,ut),e($,ce),e(ce,mt),be=!0},p:Kt,i(t){be||(U(E.$$.fragment,t),U(A.$$.fragment,t),U(C.$$.fragment,t),U(F.$$.fragment,t),U(L.$$.fragment,t),U(k.$$.fragment,t),U(q.$$.fragment,t),be=!0)},o(t){G(E.$$.fragment,t),G(A.$$.fragment,t),G(C.$$.fragment,t),G(F.$$.fragment,t),G(L.$$.fragment,t),G(k.$$.fragment,t),G(q.$$.fragment,t),be=!1},d(t){r(_),t&&r(pe),t&&r(v),R(E),t&&r(fe),t&&r(b),R(A),t&&r(he),t&&r(T),t&&r(ue),t&&r(W),t&&r(me),t&&r(j),t&&r(ge),t&&r(x),t&&r(_e),t&&r(D),R(C),t&&r(ve),t&&r(p),R(F),R(L),R(k),R(q)}}}const Yt={local:"denoising-diffusion-probabilistic-models-ddpm",sections:[{local:"overview",title:"Overview"},{local:"diffusers.DDPMScheduler",title:"DDPMScheduler"}],title:"Denoising Diffusion Probabilistic Models (DDPM)"};function Zt(bt){return Qt(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class or extends Wt{constructor(_){super();jt(this,_,Zt,Xt,zt,{})}}export{or as default,Yt as metadata};
